"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
class ScriptLoader extends react_1.default.Component {
    timeout;
    constructor(props) {
        super(props);
        this.state = {
            delayMs: props.delayMs || 0,
            src: props.src,
            timeout: null
        };
        this.componentDidMount = this.componentDidMount.bind(this);
        this.componentWillUnmount = this.componentWillUnmount.bind(this);
        this._appendScript = this._appendScript.bind(this);
        this.render = this.render.bind(this);
    }
    componentDidMount() {
        this.setState({
            timeout: setTimeout(this._appendScript, this.state.delayMs)
        });
    }
    componentWillUnmount() {
        if (this.state.timeout) {
            clearTimeout(this.state.timeout);
        }
        ;
    }
    _appendScript = () => {
        const { onCreate, onLoad, onError, delayMs, src, ...otherProps } = this.props;
        const script = document.createElement('script');
        script.src = src;
        // Add custom attributes
        for (const [attr, value] of Object.entries(otherProps)) {
            if (attr === 'onCreate' || attr === 'onLoad' || attr === 'onError' || attr === 'onSuccess') {
                continue;
            }
            script.setAttribute(attr, value);
        }
        script.onload = onLoad || null;
        script.onerror = onError || null;
        document.body.appendChild(script);
        if (onCreate) {
            onCreate();
        }
    };
    render() {
        return react_1.default.createElement(react_1.default.Fragment, null);
    }
}
exports.default = ScriptLoader;
